---
title: TextTrackList.onaddtrack
slug: Web/API/TextTrackList/onaddtrack
tags:
  - API
  - Adding Tracks
  - Event Handler
  - HTML DOM
  - HTMLMediaElement
  - Media
  - Property
  - Reference
  - addTrack
  - onaddtrack
  - track
---
<div>{{APIRef("HTML DOM")}}</div>

<p><span class="seoSummary">The <strong>{{domxref("TextTrackList")}}</strong> property <strong><code>onaddtrack</code></strong> is an event handler which is called when the {{event("addtrack")}} event occurs, indicating that a new text track has been added to the media element whose text tracks the <code>TextTrackList</code> represents.</span></p>

<p>The event is passed into the event handler in the form of a {{domxref("TrackEvent")}} object, whose {{domxref("TrackEvent.track", "track")}} property identifies the newly-added track.</p>

<div class="note">
<p><strong>Note:</strong> You can also add a handler for the <code>addtrack</code> event using {{domxref("EventTarget.addEventListener", "addEventListener()")}}.</p>
</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"><em>TextTrackList</em>.onaddtrack = <em>eventHandler</em>;</pre>

<h3 id="Value">Value</h3>

<p>Set <code>onaddtrack</code> to a function that accepts as input a {{domxref("TrackEvent")}} object which indicates in its {{domxref("TrackEvent.track", "track")}} property which video track has been added to the media.</p>

<h2 id="Usage_notes">Usage notes</h2>

<p>The {{event("addtrack")}} event is called whenever a new track is added to the media element whose video tracks are represented by the <code>TextTrackList</code> object. This happens when tracks are added to the element when the media is first attached to the element; one <code>addtrack</code> event will occur for each video track in the media resource.</p>

<h2 id="Example">Example</h2>

<p>This snippet establishes a handler for the {{event("addtrack")}} event that calls a function, <code>addToTrackList()</code>, passing in the {{domxref("VideoTrack")}} object representing the newly-added track. In this scenario, that function's role is to add the new track to a list of video tracks available to choose from.</p>

<pre class="brush: js">document.querySelector("video").textTracks.onaddtrack = function(event) {
  addToTrackList(event.track);
};
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('HTML WHATWG', '#handler-tracklist-onaddtrack', 'TextTrackList: onaddtrack')}}</td>
   <td>{{Spec2('HTML WHATWG')}}</td>
   <td> </td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.TextTrackList.onaddtrack")}}</p>

